{
	"version": "2.0.0",
	"tasks": [
		{
			"label": "dotnet-Debug-build",
			"dependsOn": [
				"dotnet-clean"
			],
			"command": "dotnet",
			"type": "process",
			"args": [
				"build",
				"--configuration=Debug",
				"/property:GenerateFullPaths=true",
				"/consoleloggerparameters:NoSummary"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": false,
				"revealProblems": "onProblem",
				"close": true
			}
		},
		{
			"label": "dotnet-Release-build",
			"dependsOn": [
				"dotnet-clean"
			],
			"command": "dotnet",
			"type": "process",
			"args": [
				"build",
				"--configuration=Release",
				"/property:GenerateFullPaths=true",
				"/consoleloggerparameters:NoSummary"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": false,
				"revealProblems": "onProblem",
				"close": true
			}
		},
		{
			"label": "dotnet-Debug-clean",
			"command": "dotnet",
			"type": "process",
			"args": [
				"clean",
				"--configuration=Debug",
				"/consoleloggerparameters:NoSummary"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": false,
				"revealProblems": "onProblem",
				"close": true
			}
		},
		{
			"label": "dotnet-Debug-run",
			"command": "dotnet",
			"type": "process",
			"args": [
				"run",
				"--project=./Node/Node.csproj",
				"--configuration=Debug",
				"/consoleloggerparameters:NoSummary",
				"--launch-profile Development"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": false,
				"revealProblems": "onProblem",
				"close": true
			}
		},
		{
			"label": "dotnet-Release-run",
			"command": "dotnet",
			"type": "process",
			"args": [
				"run",
				"--project=./Node/Node.csproj",
				"--configuration=Debug",
				"/consoleloggerparameters:NoSummary",
				"--launch-profile Production"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": false,
				"revealProblems": "onProblem",
				"close": true
			}
		},
		{
			"label": "dotnet-Release-clean",
			"command": "dotnet",
			"type": "process",
			"args": [
				"clean",
				"--configuration=Release",
				"/consoleloggerparameters:NoSummary"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": false,
				"revealProblems": "onProblem",
				"close": true
			}
		},
		{
			"label": "dotnet-Debug-test (unit)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"test",
				"--logger=trx;logfilename=\"../.info/unit.log.trx\"",
				"--results-directory=\"./.temp\"",
				"--configuration=Debug",
				"/p:CollectCoverage=true",
				"/p:CoverletOutputFormat=\"lcov,opencover,cobertura\"",
				"/p:CoverletOutput=\"../.info/unit\"",
				"/p:ExcludeByFile=\"**/Node/Program.cs\"",
				"/p:Threshold=\"90\"",
				"./Unit/Unit.csproj"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": true,
				"revealProblems": "onProblem",
				"group": "debug-test"
			}
		},
		{
			"label": "dotnet-Debug-test (integration)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"test",
				"--logger=trx;logfilename=\"./../.info/integration.log.trx\"",
				"--results-directory=\"./.temp\"",
				"--configuration=Debug",
				"/p:CollectCoverage=true",
				"/p:CoverletOutputFormat=\"lcov,opencover,cobertura\"",
				"/p:CoverletOutput=../.info/integration",
				"/p:Threshold=\"90\"",
				"./Integration/Integration.csproj"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": true,
				"revealProblems": "onProblem",
				"group": "debug-test"
			}
		},
		{
			"label": "dotnet-Debug-test (all)",
			"dependsOn": [
				"dotnet-Debug-test (unit)",
				"dotnet-Debug-test (integration)"
			]
		},
		{
			"label": "dotnet-Release-test (unit)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"test",
				"--logger=trx;logfilename=\"../.info/unit.log.trx\"",
				"--results-directory=\"./.temp\"",
				"--configuration=Release",
				"/p:CollectCoverage=true",
				"/p:CoverletOutputFormat=\"lcov,opencover,cobertura\"",
				"/p:CoverletOutput=\"../.info/unit\"",
				"/p:ExcludeByFile=\"**/Node/Program.cs\"",
				"/p:Threshold=\"90\"",
				"./Unit/Unit.csproj"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": true,
				"revealProblems": "onProblem",
				"group": "release-test"
			}
		},
		{
			"label": "dotnet-Release-test (integration)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"test",
				"--logger=trx;logfilename=\"./../.info/integration.log.trx\"",
				"--results-directory=\"./.temp\"",
				"--configuration=Release",
				"/p:CollectCoverage=true",
				"/p:CoverletOutputFormat=\"lcov,opencover,cobertura\"",
				"/p:CoverletOutput=../.info/integration",
				"/p:Threshold=\"90\"",
				"./Integration/Integration.csproj"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"echo": true,
				"reveal": "always",
				"focus": false,
				"panel": "shared",
				"showReuseMessage": true,
				"revealProblems": "onProblem",
				"group": "release-test"
			}
		},
		{
			"label": "dotnet-Release-test (all)",
			"dependsOn": [
				"dotnet-test (unit)",
				"dotnet-test (integration)"
			]
		},
		{
			"label": "cake-Release-build",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Build"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Debug-build",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Debug",
				"--target=Build"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-format",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--target=Format"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Release-test (unit)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Unit"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Debug-test (unit)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Debug",
				"--target=Unit"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Release-test (integration)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Integration"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Debug-test (integration)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Debug",
				"--target=Integration"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Release-test (all)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Test"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Debug-test (all)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Debug",
				"--target=Test"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Release-analyze",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Analyze"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Debug-analyze",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Debug",
				"--target=Analyze"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Release-benchmark",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Benchmark"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Release-publish",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Release",
				"--target=Publish"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "cake-Debug-publish",
			"command": "dotnet",
			"type": "process",
			"args": [
				"cake",
				"${workspaceFolder}/.build.cake",
				"--configuration=Debug",
				"--target=Publish"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "dotnet-Debug-watch",
			"command": "dotnet",
			"type": "process",
			"args": [
				"watch",
				"run",
				"--project",
				"${workspaceFolder}/Node/Node.csproj"
			],
			"problemMatcher": "$msCompile"
		},
		{
			"label": "dotnet-Helper-tool restore",
			"command": "dotnet",
			"type": "process",
			"args": [
				"tool",
				"restore"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"reveal": "always",
				"panel": "shared"
			}
		},
		{
			"label": "dotnet-Helper-build benchmark (Debug)",
			"command": "dotnet",
			"type": "process",
			"args": [
				"build",
				"./Benchmark/Benchmark.csproj",
				"--configuration=Debug"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"reveal": "always",
				"panel": "shared"
			}
		},
		{
			"label": "dotnet-Release-benchmark",
			"command": "dotnet",
			"type": "process",
			"args": [
				"run",
				"--project",
				"./Benchmark/Benchmark.csproj",
				"--configuration=Release"
			],
			"problemMatcher": "$msCompile",
			"presentation": {
				"reveal": "always",
				"panel": "shared"
			}
		},
		{
			"label": "cleanUp",
			"type": "shell",
			"command": "rm -rf ./.temp/*",
			"windows": {
				"command": "rm -rf ./temp/*"
			},
			"presentation": {
				"reveal": "silent",
				"panel": "new",
				"close": true
			},
			"runOptions": {
				"runOn": "folderOpen"
			}
		},
		{
			"type": "docker-build",
			"label": "docker-Debug-build",
			"dependsOn": [
				"build"
			],
			"dockerBuild": {
				"tag": "robotics/node:Development",
				"dockerfile": "${workspaceFolder}/Node/Dockerfile",
				"context": "${workspaceFolder}",
				"pull": true,
				"buildArgs": {
					"CONFIGURATION": "Debug",
				}
			},
		},
		{
			"type": "docker-build",
			"label": "docker-Release-build",
			"dependsOn": [
				"build"
			],
			"dockerBuild": {
				"tag": "robotics/node:Release",
				"dockerfile": "${workspaceFolder}/Node/Dockerfile",
				"context": "${workspaceFolder}",
				"pull": true,
				"buildArgs": {
					"CONFIGURATION": "Release",
				}
			},
		},
		{
			"type": "docker-run",
			"label": "docker-Debug-run",
			"dependsOn": [
				"docker-Debug-build"
			],
			"dockerRun": {
				"containerName": "node.Development",
				"image": "robotics/node:Development",
				"ports": [
					{
						"containerPort": 5000,
						"hostPort": 5000,
					},
				],
				"volumes": [
					{
						"localPath": "${workspaceFolder}/../../.vsdbg",
						"containerPath": "/remote_debugger",
						"permissions": "rw"
					}
				],
				"env": {
					"ASPNETCORE_ENVIRONMENT": "Debug",
				},
			},
			"netCore": {
				"appProject": "${workspaceFolder}/Node/Node.csproj",
			}
		},
		{
			"type": "docker-run",
			"label": "docker-Release-run",
			"dependsOn": [
				"docker-Release-build"
			],
			"dockerRun": {
				"containerName": "node.Release",
				"image": "robotics/node:Release",
				"ports": [
					{
						"containerPort": 5000,
						"hostPort": 5000,
					},
				],
				"env": {
					"ASPNETCORE_ENVIRONMENT": "Release"
				},
			},
			"netCore": {
				"appProject": "${workspaceFolder}/Node/Node.csproj"
			}
		},
		////
		{
			"type": "docker-build",
			"label": "docker-Attech-build",
			"dependsOn": [
				"build"
			],
			"dockerBuild": {
				"tag": "robotics/node:attech",
				"dockerfile": "${workspaceFolder}/Node/Dockerfile",
				"context": "${workspaceFolder}",
				"pull": true,
				"target": "base",
				"buildArgs": {
					"CONFIGURATION": "Debug"
				}
			}
		},
		{
			"type": "docker-run",
			"label": "docker-Attech-run",
			"dependsOn": [
				"docker-Attech-build"
			],
			"dockerRun": {
				"containerName": "node.Attech",
				"image": "robotics/node:Attech",
				"ports": [
					{
						"containerPort": 5000,
						"hostPort": 5000
					}
				],
				"volumes": [
					{
						"localPath": "${workspaceFolder}/../../.vsdbg",
						"containerPath": "/remote_debugger",
						"permissions": "rw"
					}
				],
				"env": {
					"ASPNETCORE_ENVIRONMENT": "Debug"
				}
			},
			"netCore": {
				"appProject": "${workspaceFolder}/Node/Node.csproj",
				"enableDebugging": true
			}
		}
	]
}